=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'cgi'

module Yapstone
  class AssetsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Creates an Asset Resource in the system.
    # @param asset_request [AssetRequest] The Asset Request Resource to be created.
    # @param [Hash] opts the optional parameters
    # @return [AssetResource]
    def create_asset(asset_request, opts = {})
      data, _status_code, _headers = create_asset_with_http_info(asset_request, opts)
      data
    end

    # Creates an Asset Resource in the system.
    # @param asset_request [AssetRequest] The Asset Request Resource to be created.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AssetResource, Integer, Hash)>] AssetResource data, response status code and response headers
    def create_asset_with_http_info(asset_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AssetsApi.create_asset ...'
      end
      # verify the required parameter 'asset_request' is set
      if @api_client.config.client_side_validation && asset_request.nil?
        fail ArgumentError, "Missing the required parameter 'asset_request' when calling AssetsApi.create_asset"
      end
      # resource path
      local_var_path = '/assets'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(asset_request) 

      # return_type
      return_type = opts[:return_type] || 'AssetResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AssetsApi#create_asset\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Deactivates the Asset Resource in the system.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param [Hash] opts the optional parameters
    # @return [DeactivateResponse]
    def deactivate_asset(asset_id, opts = {})
      data, _status_code, _headers = deactivate_asset_with_http_info(asset_id, opts)
      data
    end

    # Deactivates the Asset Resource in the system.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param [Hash] opts the optional parameters
    # @return [Array<(DeactivateResponse, Integer, Hash)>] DeactivateResponse data, response status code and response headers
    def deactivate_asset_with_http_info(asset_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AssetsApi.deactivate_asset ...'
      end
      # verify the required parameter 'asset_id' is set
      if @api_client.config.client_side_validation && asset_id.nil?
        fail ArgumentError, "Missing the required parameter 'asset_id' when calling AssetsApi.deactivate_asset"
      end
      # resource path
      local_var_path = '/assets/{assetId}'.sub('{' + 'assetId' + '}', CGI.escape(asset_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DeactivateResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AssetsApi#deactivate_asset\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Retrieves an Asset Resource from the system for the given assetId.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param [Hash] opts the optional parameters
    # @return [AssetResource]
    def get_asset(asset_id, opts = {})
      data, _status_code, _headers = get_asset_with_http_info(asset_id, opts)
      data
    end

    # Retrieves an Asset Resource from the system for the given assetId.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AssetResource, Integer, Hash)>] AssetResource data, response status code and response headers
    def get_asset_with_http_info(asset_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AssetsApi.get_asset ...'
      end
      # verify the required parameter 'asset_id' is set
      if @api_client.config.client_side_validation && asset_id.nil?
        fail ArgumentError, "Missing the required parameter 'asset_id' when calling AssetsApi.get_asset"
      end
      # resource path
      local_var_path = '/assets/{assetId}'.sub('{' + 'assetId' + '}', CGI.escape(asset_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AssetResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AssetsApi#get_asset\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Asset Resources the actor has access to in the system.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page page number
    # @option opts [Integer] :size Maximum number of records to return per page
    # @option opts [String] :external_id The identifier used by an external client.
    # @return [AssetsResource]
    def get_assets(opts = {})
      data, _status_code, _headers = get_assets_with_http_info(opts)
      data
    end

    # Get Asset Resources the actor has access to in the system.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page page number
    # @option opts [Integer] :size Maximum number of records to return per page
    # @option opts [String] :external_id The identifier used by an external client.
    # @return [Array<(AssetsResource, Integer, Hash)>] AssetsResource data, response status code and response headers
    def get_assets_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AssetsApi.get_assets ...'
      end
      # resource path
      local_var_path = '/assets'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
      query_params[:'externalId'] = opts[:'external_id'] if !opts[:'external_id'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AssetsResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AssetsApi#get_assets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Updates the Asset Resource.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param asset_update_request [AssetUpdateRequest] The Asset Request Resource to be created.
    # @param [Hash] opts the optional parameters
    # @return [AssetResource]
    def update_asset(asset_id, asset_update_request, opts = {})
      data, _status_code, _headers = update_asset_with_http_info(asset_id, asset_update_request, opts)
      data
    end

    # Updates the Asset Resource.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param asset_update_request [AssetUpdateRequest] The Asset Request Resource to be created.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AssetResource, Integer, Hash)>] AssetResource data, response status code and response headers
    def update_asset_with_http_info(asset_id, asset_update_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AssetsApi.update_asset ...'
      end
      # verify the required parameter 'asset_id' is set
      if @api_client.config.client_side_validation && asset_id.nil?
        fail ArgumentError, "Missing the required parameter 'asset_id' when calling AssetsApi.update_asset"
      end
      # verify the required parameter 'asset_update_request' is set
      if @api_client.config.client_side_validation && asset_update_request.nil?
        fail ArgumentError, "Missing the required parameter 'asset_update_request' when calling AssetsApi.update_asset"
      end
      # resource path
      local_var_path = '/assets/{assetId}'.sub('{' + 'assetId' + '}', CGI.escape(asset_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json-patch+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(asset_update_request) 

      # return_type
      return_type = opts[:return_type] || 'AssetResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AssetsApi#update_asset\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
