=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'cgi'

module Yapstone
  class BusinessApplicantsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Creates a Business Applicant Resource in the system.
    # @param business_applicant_request [BusinessApplicantRequest] The Business Applicant Resource to be created.
    # @param [Hash] opts the optional parameters
    # @return [BusinessApplicantResource]
    def create_business_applicant(business_applicant_request, opts = {})
      data, _status_code, _headers = create_business_applicant_with_http_info(business_applicant_request, opts)
      data
    end

    # Creates a Business Applicant Resource in the system.
    # @param business_applicant_request [BusinessApplicantRequest] The Business Applicant Resource to be created.
    # @param [Hash] opts the optional parameters
    # @return [Array<(BusinessApplicantResource, Integer, Hash)>] BusinessApplicantResource data, response status code and response headers
    def create_business_applicant_with_http_info(business_applicant_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BusinessApplicantsApi.create_business_applicant ...'
      end
      # verify the required parameter 'business_applicant_request' is set
      if @api_client.config.client_side_validation && business_applicant_request.nil?
        fail ArgumentError, "Missing the required parameter 'business_applicant_request' when calling BusinessApplicantsApi.create_business_applicant"
      end
      # resource path
      local_var_path = '/business-applicants'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(business_applicant_request) 

      # return_type
      return_type = opts[:return_type] || 'BusinessApplicantResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BusinessApplicantsApi#create_business_applicant\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Deactivates the Business Applicant Resource in the system.
    # @param applicant_id [String] The unique id of the Applicant Resource.
    # @param [Hash] opts the optional parameters
    # @return [DeactivateResponse]
    def deactivate_business_applicant(applicant_id, opts = {})
      data, _status_code, _headers = deactivate_business_applicant_with_http_info(applicant_id, opts)
      data
    end

    # Deactivates the Business Applicant Resource in the system.
    # @param applicant_id [String] The unique id of the Applicant Resource.
    # @param [Hash] opts the optional parameters
    # @return [Array<(DeactivateResponse, Integer, Hash)>] DeactivateResponse data, response status code and response headers
    def deactivate_business_applicant_with_http_info(applicant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BusinessApplicantsApi.deactivate_business_applicant ...'
      end
      # verify the required parameter 'applicant_id' is set
      if @api_client.config.client_side_validation && applicant_id.nil?
        fail ArgumentError, "Missing the required parameter 'applicant_id' when calling BusinessApplicantsApi.deactivate_business_applicant"
      end
      # resource path
      local_var_path = '/business-applicants/{applicantId}'.sub('{' + 'applicantId' + '}', CGI.escape(applicant_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DeactivateResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BusinessApplicantsApi#deactivate_business_applicant\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Retrieves an Business Applicant Resource from the system for the given applicantId.
    # @param applicant_id [String] The unique id of the Business Applicant Resource.
    # @param [Hash] opts the optional parameters
    # @return [BusinessApplicantResource]
    def get_business_applicant(applicant_id, opts = {})
      data, _status_code, _headers = get_business_applicant_with_http_info(applicant_id, opts)
      data
    end

    # Retrieves an Business Applicant Resource from the system for the given applicantId.
    # @param applicant_id [String] The unique id of the Business Applicant Resource.
    # @param [Hash] opts the optional parameters
    # @return [Array<(BusinessApplicantResource, Integer, Hash)>] BusinessApplicantResource data, response status code and response headers
    def get_business_applicant_with_http_info(applicant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BusinessApplicantsApi.get_business_applicant ...'
      end
      # verify the required parameter 'applicant_id' is set
      if @api_client.config.client_side_validation && applicant_id.nil?
        fail ArgumentError, "Missing the required parameter 'applicant_id' when calling BusinessApplicantsApi.get_business_applicant"
      end
      # resource path
      local_var_path = '/business-applicants/{applicantId}'.sub('{' + 'applicantId' + '}', CGI.escape(applicant_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'BusinessApplicantResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BusinessApplicantsApi#get_business_applicant\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get all Business Applicant Resources the actor has access to in the system.
    # @param external_id [String] The identifier used by an external client.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page page number
    # @option opts [Integer] :size Maximum number of records to return per page
    # @return [BusinessApplicantsResource]
    def get_business_applicants(external_id, opts = {})
      data, _status_code, _headers = get_business_applicants_with_http_info(external_id, opts)
      data
    end

    # Get all Business Applicant Resources the actor has access to in the system.
    # @param external_id [String] The identifier used by an external client.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page page number
    # @option opts [Integer] :size Maximum number of records to return per page
    # @return [Array<(BusinessApplicantsResource, Integer, Hash)>] BusinessApplicantsResource data, response status code and response headers
    def get_business_applicants_with_http_info(external_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BusinessApplicantsApi.get_business_applicants ...'
      end
      # verify the required parameter 'external_id' is set
      if @api_client.config.client_side_validation && external_id.nil?
        fail ArgumentError, "Missing the required parameter 'external_id' when calling BusinessApplicantsApi.get_business_applicants"
      end
      # resource path
      local_var_path = '/business-applicants'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'externalId'] = external_id
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'BusinessApplicantsResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BusinessApplicantsApi#get_business_applicants\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Updates the Business Applicant Resource.
    # @param applicant_id [String] The unique id of the BusinessApplicant Resource.
    # @param business_applicant_update_request [BusinessApplicantUpdateRequest] The Business Applicant Resource to be created after updation.
    # @param [Hash] opts the optional parameters
    # @return [BusinessApplicantResource]
    def update_business_applicant(applicant_id, business_applicant_update_request, opts = {})
      data, _status_code, _headers = update_business_applicant_with_http_info(applicant_id, business_applicant_update_request, opts)
      data
    end

    # Updates the Business Applicant Resource.
    # @param applicant_id [String] The unique id of the BusinessApplicant Resource.
    # @param business_applicant_update_request [BusinessApplicantUpdateRequest] The Business Applicant Resource to be created after updation.
    # @param [Hash] opts the optional parameters
    # @return [Array<(BusinessApplicantResource, Integer, Hash)>] BusinessApplicantResource data, response status code and response headers
    def update_business_applicant_with_http_info(applicant_id, business_applicant_update_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BusinessApplicantsApi.update_business_applicant ...'
      end
      # verify the required parameter 'applicant_id' is set
      if @api_client.config.client_side_validation && applicant_id.nil?
        fail ArgumentError, "Missing the required parameter 'applicant_id' when calling BusinessApplicantsApi.update_business_applicant"
      end
      # verify the required parameter 'business_applicant_update_request' is set
      if @api_client.config.client_side_validation && business_applicant_update_request.nil?
        fail ArgumentError, "Missing the required parameter 'business_applicant_update_request' when calling BusinessApplicantsApi.update_business_applicant"
      end
      # resource path
      local_var_path = '/business-applicants/{applicantId}'.sub('{' + 'applicantId' + '}', CGI.escape(applicant_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json-patch+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(business_applicant_update_request) 

      # return_type
      return_type = opts[:return_type] || 'BusinessApplicantResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BusinessApplicantsApi#update_business_applicant\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
