=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'cgi'

module Yapstone
  class InstrumentsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Creates an Payout Instrument Resource in the system.
    # @param payout_instrument_request [PayoutInstrumentRequest] The Payout Instrument Request Resource to be created.
    # @param [Hash] opts the optional parameters
    # @return [PayoutInstrumentResource]
    def create_instrument(payout_instrument_request, opts = {})
      data, _status_code, _headers = create_instrument_with_http_info(payout_instrument_request, opts)
      data
    end

    # Creates an Payout Instrument Resource in the system.
    # @param payout_instrument_request [PayoutInstrumentRequest] The Payout Instrument Request Resource to be created.
    # @param [Hash] opts the optional parameters
    # @return [Array<(PayoutInstrumentResource, Integer, Hash)>] PayoutInstrumentResource data, response status code and response headers
    def create_instrument_with_http_info(payout_instrument_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InstrumentsApi.create_instrument ...'
      end
      # verify the required parameter 'payout_instrument_request' is set
      if @api_client.config.client_side_validation && payout_instrument_request.nil?
        fail ArgumentError, "Missing the required parameter 'payout_instrument_request' when calling InstrumentsApi.create_instrument"
      end
      # resource path
      local_var_path = '/instruments'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(payout_instrument_request) 

      # return_type
      return_type = opts[:return_type] || 'PayoutInstrumentResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InstrumentsApi#create_instrument\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Deactivates the Payout Instrument Resource in the system.
    # @param instrument_id [String] The unique id of the Instrument Resource.
    # @param [Hash] opts the optional parameters
    # @return [DeactivateResponse]
    def deactivate_instrument(instrument_id, opts = {})
      data, _status_code, _headers = deactivate_instrument_with_http_info(instrument_id, opts)
      data
    end

    # Deactivates the Payout Instrument Resource in the system.
    # @param instrument_id [String] The unique id of the Instrument Resource.
    # @param [Hash] opts the optional parameters
    # @return [Array<(DeactivateResponse, Integer, Hash)>] DeactivateResponse data, response status code and response headers
    def deactivate_instrument_with_http_info(instrument_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InstrumentsApi.deactivate_instrument ...'
      end
      # verify the required parameter 'instrument_id' is set
      if @api_client.config.client_side_validation && instrument_id.nil?
        fail ArgumentError, "Missing the required parameter 'instrument_id' when calling InstrumentsApi.deactivate_instrument"
      end
      # resource path
      local_var_path = '/instruments/{instrumentId}'.sub('{' + 'instrumentId' + '}', CGI.escape(instrument_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DeactivateResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InstrumentsApi#deactivate_instrument\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Retrieves an Payout Instrument Resource from the system for the given payoutInstrumentId.
    # @param instrument_id [String] The unique id of the Instrument Resource.
    # @param [Hash] opts the optional parameters
    # @return [PayoutInstrumentResource]
    def get_instrument(instrument_id, opts = {})
      data, _status_code, _headers = get_instrument_with_http_info(instrument_id, opts)
      data
    end

    # Retrieves an Payout Instrument Resource from the system for the given payoutInstrumentId.
    # @param instrument_id [String] The unique id of the Instrument Resource.
    # @param [Hash] opts the optional parameters
    # @return [Array<(PayoutInstrumentResource, Integer, Hash)>] PayoutInstrumentResource data, response status code and response headers
    def get_instrument_with_http_info(instrument_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InstrumentsApi.get_instrument ...'
      end
      # verify the required parameter 'instrument_id' is set
      if @api_client.config.client_side_validation && instrument_id.nil?
        fail ArgumentError, "Missing the required parameter 'instrument_id' when calling InstrumentsApi.get_instrument"
      end
      # resource path
      local_var_path = '/instruments/{instrumentId}'.sub('{' + 'instrumentId' + '}', CGI.escape(instrument_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PayoutInstrumentResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InstrumentsApi#get_instrument\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get all Payout Instrument Resources the actor has access to in the system.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page page number
    # @option opts [Integer] :size Maximum number of records to return per page
    # @return [PayoutInstrumentsResource]
    def get_instruments(opts = {})
      data, _status_code, _headers = get_instruments_with_http_info(opts)
      data
    end

    # Get all Payout Instrument Resources the actor has access to in the system.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page page number
    # @option opts [Integer] :size Maximum number of records to return per page
    # @return [Array<(PayoutInstrumentsResource, Integer, Hash)>] PayoutInstrumentsResource data, response status code and response headers
    def get_instruments_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InstrumentsApi.get_instruments ...'
      end
      # resource path
      local_var_path = '/instruments'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PayoutInstrumentsResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InstrumentsApi#get_instruments\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Updates the PayoutInstrument Resource.
    # @param instrument_id [String] The unique id of the Instrument Resource.
    # @param payout_instrument_update_request [PayoutInstrumentUpdateRequest] The PayoutInstrument Request Resource to be updated.
    # @param [Hash] opts the optional parameters
    # @return [PayoutInstrumentResource]
    def update_instrument(instrument_id, payout_instrument_update_request, opts = {})
      data, _status_code, _headers = update_instrument_with_http_info(instrument_id, payout_instrument_update_request, opts)
      data
    end

    # Updates the PayoutInstrument Resource.
    # @param instrument_id [String] The unique id of the Instrument Resource.
    # @param payout_instrument_update_request [PayoutInstrumentUpdateRequest] The PayoutInstrument Request Resource to be updated.
    # @param [Hash] opts the optional parameters
    # @return [Array<(PayoutInstrumentResource, Integer, Hash)>] PayoutInstrumentResource data, response status code and response headers
    def update_instrument_with_http_info(instrument_id, payout_instrument_update_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InstrumentsApi.update_instrument ...'
      end
      # verify the required parameter 'instrument_id' is set
      if @api_client.config.client_side_validation && instrument_id.nil?
        fail ArgumentError, "Missing the required parameter 'instrument_id' when calling InstrumentsApi.update_instrument"
      end
      # verify the required parameter 'payout_instrument_update_request' is set
      if @api_client.config.client_side_validation && payout_instrument_update_request.nil?
        fail ArgumentError, "Missing the required parameter 'payout_instrument_update_request' when calling InstrumentsApi.update_instrument"
      end
      # resource path
      local_var_path = '/instruments/{instrumentId}'.sub('{' + 'instrumentId' + '}', CGI.escape(instrument_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json-patch+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(payout_instrument_update_request) 

      # return_type
      return_type = opts[:return_type] || 'PayoutInstrumentResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InstrumentsApi#update_instrument\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
