=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'cgi'

module Yapstone
  class MarketplacesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add a new market place in a given contract.
    # @param contract_id [String] The unique id of the Contract Resource.
    # @param marketplace_product_add [MarketplaceProductAdd] The market place details
    # @param [Hash] opts the optional parameters
    # @return [MarketplaceProductResource]
    def add_marketplace_product(contract_id, marketplace_product_add, opts = {})
      data, _status_code, _headers = add_marketplace_product_with_http_info(contract_id, marketplace_product_add, opts)
      data
    end

    # Add a new market place in a given contract.
    # @param contract_id [String] The unique id of the Contract Resource.
    # @param marketplace_product_add [MarketplaceProductAdd] The market place details
    # @param [Hash] opts the optional parameters
    # @return [Array<(MarketplaceProductResource, Integer, Hash)>] MarketplaceProductResource data, response status code and response headers
    def add_marketplace_product_with_http_info(contract_id, marketplace_product_add, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MarketplacesApi.add_marketplace_product ...'
      end
      # verify the required parameter 'contract_id' is set
      if @api_client.config.client_side_validation && contract_id.nil?
        fail ArgumentError, "Missing the required parameter 'contract_id' when calling MarketplacesApi.add_marketplace_product"
      end
      # verify the required parameter 'marketplace_product_add' is set
      if @api_client.config.client_side_validation && marketplace_product_add.nil?
        fail ArgumentError, "Missing the required parameter 'marketplace_product_add' when calling MarketplacesApi.add_marketplace_product"
      end
      # resource path
      local_var_path = '/contracts/{contractId}/marketplaces'.sub('{' + 'contractId' + '}', CGI.escape(contract_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(marketplace_product_add) 

      # return_type
      return_type = opts[:return_type] || 'MarketplaceProductResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MarketplacesApi#add_marketplace_product\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # deactivate the Marketplace Product Resource.
    # @param contract_id [String] The unique id of the Contract Resource.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param deactivate_request [DeactivateRequest] The details of the deactivation process.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def deactivate_marketplace_product(contract_id, asset_id, deactivate_request, opts = {})
      deactivate_marketplace_product_with_http_info(contract_id, asset_id, deactivate_request, opts)
      nil
    end

    # deactivate the Marketplace Product Resource.
    # @param contract_id [String] The unique id of the Contract Resource.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param deactivate_request [DeactivateRequest] The details of the deactivation process.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def deactivate_marketplace_product_with_http_info(contract_id, asset_id, deactivate_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MarketplacesApi.deactivate_marketplace_product ...'
      end
      # verify the required parameter 'contract_id' is set
      if @api_client.config.client_side_validation && contract_id.nil?
        fail ArgumentError, "Missing the required parameter 'contract_id' when calling MarketplacesApi.deactivate_marketplace_product"
      end
      # verify the required parameter 'asset_id' is set
      if @api_client.config.client_side_validation && asset_id.nil?
        fail ArgumentError, "Missing the required parameter 'asset_id' when calling MarketplacesApi.deactivate_marketplace_product"
      end
      # verify the required parameter 'deactivate_request' is set
      if @api_client.config.client_side_validation && deactivate_request.nil?
        fail ArgumentError, "Missing the required parameter 'deactivate_request' when calling MarketplacesApi.deactivate_marketplace_product"
      end
      # resource path
      local_var_path = '/contracts/{contractId}/marketplaces/{assetId}'.sub('{' + 'contractId' + '}', CGI.escape(contract_id.to_s).gsub('%2F', '/')).sub('{' + 'assetId' + '}', CGI.escape(asset_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deactivate_request) 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MarketplacesApi#deactivate_marketplace_product\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Retrieves an Marketplace Resource from the system for the given contractId and assetId.
    # @param contract_id [String] The unique id of the Contract Resource.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param [Hash] opts the optional parameters
    # @return [MarketplaceProductResource]
    def get_marketplace_product_by_asset_id(contract_id, asset_id, opts = {})
      data, _status_code, _headers = get_marketplace_product_by_asset_id_with_http_info(contract_id, asset_id, opts)
      data
    end

    # Retrieves an Marketplace Resource from the system for the given contractId and assetId.
    # @param contract_id [String] The unique id of the Contract Resource.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param [Hash] opts the optional parameters
    # @return [Array<(MarketplaceProductResource, Integer, Hash)>] MarketplaceProductResource data, response status code and response headers
    def get_marketplace_product_by_asset_id_with_http_info(contract_id, asset_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MarketplacesApi.get_marketplace_product_by_asset_id ...'
      end
      # verify the required parameter 'contract_id' is set
      if @api_client.config.client_side_validation && contract_id.nil?
        fail ArgumentError, "Missing the required parameter 'contract_id' when calling MarketplacesApi.get_marketplace_product_by_asset_id"
      end
      # verify the required parameter 'asset_id' is set
      if @api_client.config.client_side_validation && asset_id.nil?
        fail ArgumentError, "Missing the required parameter 'asset_id' when calling MarketplacesApi.get_marketplace_product_by_asset_id"
      end
      # resource path
      local_var_path = '/contracts/{contractId}/marketplaces/{assetId}'.sub('{' + 'contractId' + '}', CGI.escape(contract_id.to_s).gsub('%2F', '/')).sub('{' + 'assetId' + '}', CGI.escape(asset_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'MarketplaceProductResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MarketplacesApi#get_marketplace_product_by_asset_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Updates the Marketplace Resource in a given Contract Resource.
    # @param contract_id [String] The unique id of the Contract Resource.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param marketplace_product_update [MarketplaceProductUpdate] The Market Resource to be updated.
    # @param [Hash] opts the optional parameters
    # @return [MarketplaceProductResource]
    def update_marketplace_product_by_contract_id(contract_id, asset_id, marketplace_product_update, opts = {})
      data, _status_code, _headers = update_marketplace_product_by_contract_id_with_http_info(contract_id, asset_id, marketplace_product_update, opts)
      data
    end

    # Updates the Marketplace Resource in a given Contract Resource.
    # @param contract_id [String] The unique id of the Contract Resource.
    # @param asset_id [String] The unique id of the Asset Resource.
    # @param marketplace_product_update [MarketplaceProductUpdate] The Market Resource to be updated.
    # @param [Hash] opts the optional parameters
    # @return [Array<(MarketplaceProductResource, Integer, Hash)>] MarketplaceProductResource data, response status code and response headers
    def update_marketplace_product_by_contract_id_with_http_info(contract_id, asset_id, marketplace_product_update, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MarketplacesApi.update_marketplace_product_by_contract_id ...'
      end
      # verify the required parameter 'contract_id' is set
      if @api_client.config.client_side_validation && contract_id.nil?
        fail ArgumentError, "Missing the required parameter 'contract_id' when calling MarketplacesApi.update_marketplace_product_by_contract_id"
      end
      # verify the required parameter 'asset_id' is set
      if @api_client.config.client_side_validation && asset_id.nil?
        fail ArgumentError, "Missing the required parameter 'asset_id' when calling MarketplacesApi.update_marketplace_product_by_contract_id"
      end
      # verify the required parameter 'marketplace_product_update' is set
      if @api_client.config.client_side_validation && marketplace_product_update.nil?
        fail ArgumentError, "Missing the required parameter 'marketplace_product_update' when calling MarketplacesApi.update_marketplace_product_by_contract_id"
      end
      # resource path
      local_var_path = '/contracts/{contractId}/marketplaces/{assetId}'.sub('{' + 'contractId' + '}', CGI.escape(contract_id.to_s).gsub('%2F', '/')).sub('{' + 'assetId' + '}', CGI.escape(asset_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json-patch+json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(marketplace_product_update) 

      # return_type
      return_type = opts[:return_type] || 'MarketplaceProductResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MarketplacesApi#update_marketplace_product_by_contract_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
