=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'cgi'

module Yapstone
  class PayoutProductsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Retrieves a Payout Product
    # Retrieves a Payout Product
    # @param product_id [String] The unique id of Product Resource.
    # @param [Hash] opts the optional parameters
    # @return [PayoutProductResource]
    def get_payout_product(product_id, opts = {})
      data, _status_code, _headers = get_payout_product_with_http_info(product_id, opts)
      data
    end

    # Retrieves a Payout Product
    # Retrieves a Payout Product
    # @param product_id [String] The unique id of Product Resource.
    # @param [Hash] opts the optional parameters
    # @return [Array<(PayoutProductResource, Integer, Hash)>] PayoutProductResource data, response status code and response headers
    def get_payout_product_with_http_info(product_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PayoutProductsApi.get_payout_product ...'
      end
      # verify the required parameter 'product_id' is set
      if @api_client.config.client_side_validation && product_id.nil?
        fail ArgumentError, "Missing the required parameter 'product_id' when calling PayoutProductsApi.get_payout_product"
      end
      # resource path
      local_var_path = '/payout-products/{productId}'.sub('{' + 'productId' + '}', CGI.escape(product_id.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PayoutProductResource' 

      # auth_names
      auth_names = opts[:auth_names] || ['Bearer']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PayoutProductsApi#get_payout_product\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
