=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # The address of the application, asset, bank, etc.
  class AddressResource
    # The street address line 1.
    attr_accessor :street1

    # The street address line 2.
    attr_accessor :street2

    # The street address line 3.
    attr_accessor :street3

    # The street address line 4.
    attr_accessor :street4

    # The name of the city.
    attr_accessor :city

    # The state or province where the address resides.
    attr_accessor :state

    # The postal code of the address.
    attr_accessor :postal_code

    # The 3-letter countryCode of the address.
    attr_accessor :country_code

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'street1' => :'street1',
        :'street2' => :'street2',
        :'street3' => :'street3',
        :'street4' => :'street4',
        :'city' => :'city',
        :'state' => :'state',
        :'postal_code' => :'postalCode',
        :'country_code' => :'countryCode'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'street1' => :'String',
        :'street2' => :'String',
        :'street3' => :'String',
        :'street4' => :'String',
        :'city' => :'String',
        :'state' => :'String',
        :'postal_code' => :'String',
        :'country_code' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::AddressResource` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::AddressResource`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'street1')
        self.street1 = attributes[:'street1']
      end

      if attributes.key?(:'street2')
        self.street2 = attributes[:'street2']
      end

      if attributes.key?(:'street3')
        self.street3 = attributes[:'street3']
      end

      if attributes.key?(:'street4')
        self.street4 = attributes[:'street4']
      end

      if attributes.key?(:'city')
        self.city = attributes[:'city']
      end

      if attributes.key?(:'state')
        self.state = attributes[:'state']
      end

      if attributes.key?(:'postal_code')
        self.postal_code = attributes[:'postal_code']
      end

      if attributes.key?(:'country_code')
        self.country_code = attributes[:'country_code']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@street1.nil? && @street1.to_s.length > 2048
        invalid_properties.push('invalid value for "street1", the character length must be smaller than or equal to 2048.')
      end

      if !@street2.nil? && @street2.to_s.length > 2048
        invalid_properties.push('invalid value for "street2", the character length must be smaller than or equal to 2048.')
      end

      if !@street3.nil? && @street3.to_s.length > 2048
        invalid_properties.push('invalid value for "street3", the character length must be smaller than or equal to 2048.')
      end

      if !@street4.nil? && @street4.to_s.length > 2048
        invalid_properties.push('invalid value for "street4", the character length must be smaller than or equal to 2048.')
      end

      if !@city.nil? && @city.to_s.length > 255
        invalid_properties.push('invalid value for "city", the character length must be smaller than or equal to 255.')
      end

      if !@city.nil? && @city.to_s.length < 2
        invalid_properties.push('invalid value for "city", the character length must be great than or equal to 2.')
      end

      if !@state.nil? && @state.to_s.length > 255
        invalid_properties.push('invalid value for "state", the character length must be smaller than or equal to 255.')
      end

      if !@state.nil? && @state.to_s.length < 2
        invalid_properties.push('invalid value for "state", the character length must be great than or equal to 2.')
      end

      if !@postal_code.nil? && @postal_code.to_s.length > 64
        invalid_properties.push('invalid value for "postal_code", the character length must be smaller than or equal to 64.')
      end

      if !@postal_code.nil? && @postal_code.to_s.length < 1
        invalid_properties.push('invalid value for "postal_code", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !@postal_code.nil? && @postal_code !~ pattern
        invalid_properties.push("invalid value for \"postal_code\", must conform to the pattern #{pattern}.")
      end

      if @country_code.nil?
        invalid_properties.push('invalid value for "country_code", country_code cannot be nil.')
      end

      if @country_code.to_s.length > 3
        invalid_properties.push('invalid value for "country_code", the character length must be smaller than or equal to 3.')
      end

      if @country_code.to_s.length < 3
        invalid_properties.push('invalid value for "country_code", the character length must be great than or equal to 3.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@street1.nil? && @street1.to_s.length > 2048
      return false if !@street2.nil? && @street2.to_s.length > 2048
      return false if !@street3.nil? && @street3.to_s.length > 2048
      return false if !@street4.nil? && @street4.to_s.length > 2048
      return false if !@city.nil? && @city.to_s.length > 255
      return false if !@city.nil? && @city.to_s.length < 2
      return false if !@state.nil? && @state.to_s.length > 255
      return false if !@state.nil? && @state.to_s.length < 2
      return false if !@postal_code.nil? && @postal_code.to_s.length > 64
      return false if !@postal_code.nil? && @postal_code.to_s.length < 1
      return false if !@postal_code.nil? && @postal_code !~ Regexp.new(/.*[^\s].*/)
      return false if @country_code.nil?
      return false if @country_code.to_s.length > 3
      return false if @country_code.to_s.length < 3
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] street1 Value to be assigned
    def street1=(street1)
      if !street1.nil? && street1.to_s.length > 2048
        fail ArgumentError, 'invalid value for "street1", the character length must be smaller than or equal to 2048.'
      end

      @street1 = street1
    end

    # Custom attribute writer method with validation
    # @param [Object] street2 Value to be assigned
    def street2=(street2)
      if !street2.nil? && street2.to_s.length > 2048
        fail ArgumentError, 'invalid value for "street2", the character length must be smaller than or equal to 2048.'
      end

      @street2 = street2
    end

    # Custom attribute writer method with validation
    # @param [Object] street3 Value to be assigned
    def street3=(street3)
      if !street3.nil? && street3.to_s.length > 2048
        fail ArgumentError, 'invalid value for "street3", the character length must be smaller than or equal to 2048.'
      end

      @street3 = street3
    end

    # Custom attribute writer method with validation
    # @param [Object] street4 Value to be assigned
    def street4=(street4)
      if !street4.nil? && street4.to_s.length > 2048
        fail ArgumentError, 'invalid value for "street4", the character length must be smaller than or equal to 2048.'
      end

      @street4 = street4
    end

    # Custom attribute writer method with validation
    # @param [Object] city Value to be assigned
    def city=(city)
      if !city.nil? && city.to_s.length > 255
        fail ArgumentError, 'invalid value for "city", the character length must be smaller than or equal to 255.'
      end

      if !city.nil? && city.to_s.length < 2
        fail ArgumentError, 'invalid value for "city", the character length must be great than or equal to 2.'
      end

      @city = city
    end

    # Custom attribute writer method with validation
    # @param [Object] state Value to be assigned
    def state=(state)
      if !state.nil? && state.to_s.length > 255
        fail ArgumentError, 'invalid value for "state", the character length must be smaller than or equal to 255.'
      end

      if !state.nil? && state.to_s.length < 2
        fail ArgumentError, 'invalid value for "state", the character length must be great than or equal to 2.'
      end

      @state = state
    end

    # Custom attribute writer method with validation
    # @param [Object] postal_code Value to be assigned
    def postal_code=(postal_code)
      if !postal_code.nil? && postal_code.to_s.length > 64
        fail ArgumentError, 'invalid value for "postal_code", the character length must be smaller than or equal to 64.'
      end

      if !postal_code.nil? && postal_code.to_s.length < 1
        fail ArgumentError, 'invalid value for "postal_code", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !postal_code.nil? && postal_code !~ pattern
        fail ArgumentError, "invalid value for \"postal_code\", must conform to the pattern #{pattern}."
      end

      @postal_code = postal_code
    end

    # Custom attribute writer method with validation
    # @param [Object] country_code Value to be assigned
    def country_code=(country_code)
      if country_code.nil?
        fail ArgumentError, 'country_code cannot be nil'
      end

      if country_code.to_s.length > 3
        fail ArgumentError, 'invalid value for "country_code", the character length must be smaller than or equal to 3.'
      end

      if country_code.to_s.length < 3
        fail ArgumentError, 'invalid value for "country_code", the character length must be great than or equal to 3.'
      end

      @country_code = country_code
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          street1 == o.street1 &&
          street2 == o.street2 &&
          street3 == o.street3 &&
          street4 == o.street4 &&
          city == o.city &&
          state == o.state &&
          postal_code == o.postal_code &&
          country_code == o.country_code
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [street1, street2, street3, street4, city, state, postal_code, country_code].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
