=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # The Applicant resource contains information about the person.
  class ApplicantResource
    # The resource identifier for the applicant.
    attr_accessor :id

    attr_accessor :status

    attr_accessor :type

    # The partners externalId id for the Applicant.
    attr_accessor :external_id

    attr_accessor :mkt_place_applicant

    # A list of social networks the applicant belongs to.
    attr_accessor :social_networks

    # supported language
    attr_accessor :language

    # brand id
    attr_accessor :brand

    attr_accessor :consents

    # The reportingTag for the applicant.
    attr_accessor :reporting_tag

    # At the time of creation, value is defaulted to False.
    attr_accessor :no_post_booking

    # Products requested by marketplace.
    attr_accessor :products

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'status' => :'status',
        :'type' => :'type',
        :'external_id' => :'externalId',
        :'mkt_place_applicant' => :'mktPlaceApplicant',
        :'social_networks' => :'socialNetworks',
        :'language' => :'language',
        :'brand' => :'brand',
        :'consents' => :'consents',
        :'reporting_tag' => :'reportingTag',
        :'no_post_booking' => :'noPostBooking',
        :'products' => :'products'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'id' => :'String',
        :'status' => :'EntityProductStatusResource',
        :'type' => :'String',
        :'external_id' => :'String',
        :'mkt_place_applicant' => :'MarketPlaceApplicantResource',
        :'social_networks' => :'Array<SocialNetworkResource>',
        :'language' => :'String',
        :'brand' => :'String',
        :'consents' => :'Array<ApplicantConsentResource>',
        :'reporting_tag' => :'String',
        :'no_post_booking' => :'Boolean',
        :'products' => :'Array<Product>'
      }
    end

    # discriminator's property name in OpenAPI v3
    def self.openapi_discriminator_name
      :'type'
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::ApplicantResource` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::ApplicantResource`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.key?(:'external_id')
        self.external_id = attributes[:'external_id']
      end

      if attributes.key?(:'mkt_place_applicant')
        self.mkt_place_applicant = attributes[:'mkt_place_applicant']
      end

      if attributes.key?(:'social_networks')
        if (value = attributes[:'social_networks']).is_a?(Array)
          self.social_networks = value
        end
      end

      if attributes.key?(:'language')
        self.language = attributes[:'language']
      end

      if attributes.key?(:'brand')
        self.brand = attributes[:'brand']
      end

      if attributes.key?(:'consents')
        if (value = attributes[:'consents']).is_a?(Array)
          self.consents = value
        end
      end

      if attributes.key?(:'reporting_tag')
        self.reporting_tag = attributes[:'reporting_tag']
      end

      if attributes.key?(:'no_post_booking')
        self.no_post_booking = attributes[:'no_post_booking']
      else
        self.no_post_booking = false
      end

      if attributes.key?(:'products')
        if (value = attributes[:'products']).is_a?(Array)
          self.products = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @type.nil?
        invalid_properties.push('invalid value for "type", type cannot be nil.')
      end

      if !@external_id.nil? && @external_id.to_s.length > 255
        invalid_properties.push('invalid value for "external_id", the character length must be smaller than or equal to 255.')
      end

      if !@external_id.nil? && @external_id.to_s.length < 1
        invalid_properties.push('invalid value for "external_id", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !@external_id.nil? && @external_id !~ pattern
        invalid_properties.push("invalid value for \"external_id\", must conform to the pattern #{pattern}.")
      end

      if @language.nil?
        invalid_properties.push('invalid value for "language", language cannot be nil.')
      end

      if @brand.nil?
        invalid_properties.push('invalid value for "brand", brand cannot be nil.')
      end

      if !@reporting_tag.nil? && @reporting_tag.to_s.length > 100
        invalid_properties.push('invalid value for "reporting_tag", the character length must be smaller than or equal to 100.')
      end

      if !@reporting_tag.nil? && @reporting_tag.to_s.length < 2
        invalid_properties.push('invalid value for "reporting_tag", the character length must be great than or equal to 2.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @type.nil?
      return false if !@external_id.nil? && @external_id.to_s.length > 255
      return false if !@external_id.nil? && @external_id.to_s.length < 1
      return false if !@external_id.nil? && @external_id !~ Regexp.new(/.*[^\s].*/)
      return false if @language.nil?
      return false if @brand.nil?
      return false if !@reporting_tag.nil? && @reporting_tag.to_s.length > 100
      return false if !@reporting_tag.nil? && @reporting_tag.to_s.length < 2
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] external_id Value to be assigned
    def external_id=(external_id)
      if !external_id.nil? && external_id.to_s.length > 255
        fail ArgumentError, 'invalid value for "external_id", the character length must be smaller than or equal to 255.'
      end

      if !external_id.nil? && external_id.to_s.length < 1
        fail ArgumentError, 'invalid value for "external_id", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !external_id.nil? && external_id !~ pattern
        fail ArgumentError, "invalid value for \"external_id\", must conform to the pattern #{pattern}."
      end

      @external_id = external_id
    end

    # Custom attribute writer method with validation
    # @param [Object] reporting_tag Value to be assigned
    def reporting_tag=(reporting_tag)
      if !reporting_tag.nil? && reporting_tag.to_s.length > 100
        fail ArgumentError, 'invalid value for "reporting_tag", the character length must be smaller than or equal to 100.'
      end

      if !reporting_tag.nil? && reporting_tag.to_s.length < 2
        fail ArgumentError, 'invalid value for "reporting_tag", the character length must be great than or equal to 2.'
      end

      @reporting_tag = reporting_tag
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          status == o.status &&
          type == o.type &&
          external_id == o.external_id &&
          mkt_place_applicant == o.mkt_place_applicant &&
          social_networks == o.social_networks &&
          language == o.language &&
          brand == o.brand &&
          consents == o.consents &&
          reporting_tag == o.reporting_tag &&
          no_post_booking == o.no_post_booking &&
          products == o.products
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [id, status, type, external_id, mkt_place_applicant, social_networks, language, brand, consents, reporting_tag, no_post_booking, products].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
