=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # The Bank account information.
  class BankAccountResource
    # The type of bank account [CHECKING]
    attr_accessor :type

    # The name on the account.
    attr_accessor :name_on_account

    # The ISO currency code enum that the bank account will accept funds as.
    attr_accessor :currency

    attr_accessor :bank_account_data

    # The bank name.
    attr_accessor :bank_name

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'type' => :'type',
        :'name_on_account' => :'nameOnAccount',
        :'currency' => :'currency',
        :'bank_account_data' => :'bankAccountData',
        :'bank_name' => :'bankName'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'type' => :'String',
        :'name_on_account' => :'String',
        :'currency' => :'String',
        :'bank_account_data' => :'BankAccountDataResource',
        :'bank_name' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::BankAccountResource` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::BankAccountResource`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.key?(:'name_on_account')
        self.name_on_account = attributes[:'name_on_account']
      end

      if attributes.key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.key?(:'bank_account_data')
        self.bank_account_data = attributes[:'bank_account_data']
      end

      if attributes.key?(:'bank_name')
        self.bank_name = attributes[:'bank_name']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @type.nil?
        invalid_properties.push('invalid value for "type", type cannot be nil.')
      end

      if !@name_on_account.nil? && @name_on_account.to_s.length > 99
        invalid_properties.push('invalid value for "name_on_account", the character length must be smaller than or equal to 99.')
      end

      if !@name_on_account.nil? && @name_on_account.to_s.length < 3
        invalid_properties.push('invalid value for "name_on_account", the character length must be great than or equal to 3.')
      end

      if @currency.nil?
        invalid_properties.push('invalid value for "currency", currency cannot be nil.')
      end

      if @bank_account_data.nil?
        invalid_properties.push('invalid value for "bank_account_data", bank_account_data cannot be nil.')
      end

      if !@bank_name.nil? && @bank_name.to_s.length > 36
        invalid_properties.push('invalid value for "bank_name", the character length must be smaller than or equal to 36.')
      end

      if !@bank_name.nil? && @bank_name.to_s.length < 2
        invalid_properties.push('invalid value for "bank_name", the character length must be great than or equal to 2.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @type.nil?
      type_validator = EnumAttributeValidator.new('String', ["CHECKING"])
      return false unless type_validator.valid?(@type)
      return false if !@name_on_account.nil? && @name_on_account.to_s.length > 99
      return false if !@name_on_account.nil? && @name_on_account.to_s.length < 3
      return false if @currency.nil?
      return false if @bank_account_data.nil?
      return false if !@bank_name.nil? && @bank_name.to_s.length > 36
      return false if !@bank_name.nil? && @bank_name.to_s.length < 2
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] type Object to be assigned
    def type=(type)
      validator = EnumAttributeValidator.new('String', ["CHECKING"])
      unless validator.valid?(type)
        fail ArgumentError, "invalid value for \"type\", must be one of #{validator.allowable_values}."
      end
      @type = type
    end

    # Custom attribute writer method with validation
    # @param [Object] name_on_account Value to be assigned
    def name_on_account=(name_on_account)
      if !name_on_account.nil? && name_on_account.to_s.length > 99
        fail ArgumentError, 'invalid value for "name_on_account", the character length must be smaller than or equal to 99.'
      end

      if !name_on_account.nil? && name_on_account.to_s.length < 3
        fail ArgumentError, 'invalid value for "name_on_account", the character length must be great than or equal to 3.'
      end

      @name_on_account = name_on_account
    end

    # Custom attribute writer method with validation
    # @param [Object] bank_name Value to be assigned
    def bank_name=(bank_name)
      if !bank_name.nil? && bank_name.to_s.length > 36
        fail ArgumentError, 'invalid value for "bank_name", the character length must be smaller than or equal to 36.'
      end

      if !bank_name.nil? && bank_name.to_s.length < 2
        fail ArgumentError, 'invalid value for "bank_name", the character length must be great than or equal to 2.'
      end

      @bank_name = bank_name
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          type == o.type &&
          name_on_account == o.name_on_account &&
          currency == o.currency &&
          bank_account_data == o.bank_account_data &&
          bank_name == o.bank_name
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [type, name_on_account, currency, bank_account_data, bank_name].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
