=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # The Business Applicant Resource request.  Contains all of the required fields to create an Business Applicant resource.
  class BusinessApplicantUpdateRequest
    attr_accessor :primary_contact

    attr_accessor :business_profile

    # The partners externalId id for the Business Applicant.
    attr_accessor :external_id

    attr_accessor :mkt_place_applicant

    # A list of social networks the applicant belongs to.
    attr_accessor :social_networks

    attr_accessor :status

    attr_accessor :consents

    attr_accessor :principal_owner

    # List of edits to beneficial owners of the property.
    attr_accessor :additional_owners_update

    # Products requested by marketplace.
    attr_accessor :products

    # value can be changed by only internal user.
    attr_accessor :no_post_booking

    # language used to communicate
    attr_accessor :language

    # brand id of market place
    attr_accessor :brand

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'primary_contact' => :'primaryContact',
        :'business_profile' => :'businessProfile',
        :'external_id' => :'externalId',
        :'mkt_place_applicant' => :'mktPlaceApplicant',
        :'social_networks' => :'socialNetworks',
        :'status' => :'status',
        :'consents' => :'consents',
        :'principal_owner' => :'principalOwner',
        :'additional_owners_update' => :'additionalOwnersUpdate',
        :'products' => :'products',
        :'no_post_booking' => :'noPostBooking',
        :'language' => :'language',
        :'brand' => :'brand'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'primary_contact' => :'PrimaryContactResource',
        :'business_profile' => :'BusinessProfileResource',
        :'external_id' => :'String',
        :'mkt_place_applicant' => :'MarketPlaceApplicantResource',
        :'social_networks' => :'Array<SocialNetworkResource>',
        :'status' => :'EntityProductStatusResource',
        :'consents' => :'Array<ApplicantConsentRequest>',
        :'principal_owner' => :'BeneficialOwnerResource',
        :'additional_owners_update' => :'Array<BeneficialOwnersPatch>',
        :'products' => :'Array<Product>',
        :'no_post_booking' => :'Boolean',
        :'language' => :'String',
        :'brand' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::BusinessApplicantUpdateRequest` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::BusinessApplicantUpdateRequest`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'primary_contact')
        self.primary_contact = attributes[:'primary_contact']
      end

      if attributes.key?(:'business_profile')
        self.business_profile = attributes[:'business_profile']
      end

      if attributes.key?(:'external_id')
        self.external_id = attributes[:'external_id']
      end

      if attributes.key?(:'mkt_place_applicant')
        self.mkt_place_applicant = attributes[:'mkt_place_applicant']
      end

      if attributes.key?(:'social_networks')
        if (value = attributes[:'social_networks']).is_a?(Array)
          self.social_networks = value
        end
      end

      if attributes.key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.key?(:'consents')
        if (value = attributes[:'consents']).is_a?(Array)
          self.consents = value
        end
      end

      if attributes.key?(:'principal_owner')
        self.principal_owner = attributes[:'principal_owner']
      end

      if attributes.key?(:'additional_owners_update')
        if (value = attributes[:'additional_owners_update']).is_a?(Array)
          self.additional_owners_update = value
        end
      end

      if attributes.key?(:'products')
        if (value = attributes[:'products']).is_a?(Array)
          self.products = value
        end
      end

      if attributes.key?(:'no_post_booking')
        self.no_post_booking = attributes[:'no_post_booking']
      end

      if attributes.key?(:'language')
        self.language = attributes[:'language']
      end

      if attributes.key?(:'brand')
        self.brand = attributes[:'brand']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @business_profile.nil?
        invalid_properties.push('invalid value for "business_profile", business_profile cannot be nil.')
      end

      if !@external_id.nil? && @external_id.to_s.length > 255
        invalid_properties.push('invalid value for "external_id", the character length must be smaller than or equal to 255.')
      end

      if !@external_id.nil? && @external_id.to_s.length < 1
        invalid_properties.push('invalid value for "external_id", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !@external_id.nil? && @external_id !~ pattern
        invalid_properties.push("invalid value for \"external_id\", must conform to the pattern #{pattern}.")
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @business_profile.nil?
      return false if !@external_id.nil? && @external_id.to_s.length > 255
      return false if !@external_id.nil? && @external_id.to_s.length < 1
      return false if !@external_id.nil? && @external_id !~ Regexp.new(/.*[^\s].*/)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] external_id Value to be assigned
    def external_id=(external_id)
      if !external_id.nil? && external_id.to_s.length > 255
        fail ArgumentError, 'invalid value for "external_id", the character length must be smaller than or equal to 255.'
      end

      if !external_id.nil? && external_id.to_s.length < 1
        fail ArgumentError, 'invalid value for "external_id", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !external_id.nil? && external_id !~ pattern
        fail ArgumentError, "invalid value for \"external_id\", must conform to the pattern #{pattern}."
      end

      @external_id = external_id
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          primary_contact == o.primary_contact &&
          business_profile == o.business_profile &&
          external_id == o.external_id &&
          mkt_place_applicant == o.mkt_place_applicant &&
          social_networks == o.social_networks &&
          status == o.status &&
          consents == o.consents &&
          principal_owner == o.principal_owner &&
          additional_owners_update == o.additional_owners_update &&
          products == o.products &&
          no_post_booking == o.no_post_booking &&
          language == o.language &&
          brand == o.brand
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [primary_contact, business_profile, external_id, mkt_place_applicant, social_networks, status, consents, principal_owner, additional_owners_update, products, no_post_booking, language, brand].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
