=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # Payment card details.
  class CardDataResource
    # Type of the card ( DEBIT, CREDIT)
    attr_accessor :card_type

    # Issuing authority
    attr_accessor :brand

    attr_accessor :card_token_source

    attr_accessor :expiration_date

    attr_accessor :billing_address

    # Name on the card
    attr_accessor :card_holder_name

    # The token to get the card details from vault.
    attr_accessor :card_token_data

    # The card number.
    attr_accessor :card_number

    # CVV number.
    attr_accessor :cvv

    # Currency.
    attr_accessor :currency

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'card_type' => :'cardType',
        :'brand' => :'brand',
        :'card_token_source' => :'cardTokenSource',
        :'expiration_date' => :'expirationDate',
        :'billing_address' => :'billingAddress',
        :'card_holder_name' => :'cardHolderName',
        :'card_token_data' => :'cardTokenData',
        :'card_number' => :'cardNumber',
        :'cvv' => :'cvv',
        :'currency' => :'currency'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'card_type' => :'String',
        :'brand' => :'String',
        :'card_token_source' => :'String',
        :'expiration_date' => :'ExpirationDateResource',
        :'billing_address' => :'AddressResource',
        :'card_holder_name' => :'String',
        :'card_token_data' => :'String',
        :'card_number' => :'String',
        :'cvv' => :'String',
        :'currency' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::CardDataResource` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::CardDataResource`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'card_type')
        self.card_type = attributes[:'card_type']
      end

      if attributes.key?(:'brand')
        self.brand = attributes[:'brand']
      end

      if attributes.key?(:'card_token_source')
        self.card_token_source = attributes[:'card_token_source']
      end

      if attributes.key?(:'expiration_date')
        self.expiration_date = attributes[:'expiration_date']
      end

      if attributes.key?(:'billing_address')
        self.billing_address = attributes[:'billing_address']
      end

      if attributes.key?(:'card_holder_name')
        self.card_holder_name = attributes[:'card_holder_name']
      end

      if attributes.key?(:'card_token_data')
        self.card_token_data = attributes[:'card_token_data']
      end

      if attributes.key?(:'card_number')
        self.card_number = attributes[:'card_number']
      end

      if attributes.key?(:'cvv')
        self.cvv = attributes[:'cvv']
      end

      if attributes.key?(:'currency')
        self.currency = attributes[:'currency']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@card_number.nil? && @card_number.to_s.length < 12
        invalid_properties.push('invalid value for "card_number", the character length must be great than or equal to 12.')
      end

      if !@cvv.nil? && @cvv.to_s.length > 4
        invalid_properties.push('invalid value for "cvv", the character length must be smaller than or equal to 4.')
      end

      if !@cvv.nil? && @cvv.to_s.length < 3
        invalid_properties.push('invalid value for "cvv", the character length must be great than or equal to 3.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      card_type_validator = EnumAttributeValidator.new('String', ["DEBIT", "CREDIT"])
      return false unless card_type_validator.valid?(@card_type)
      brand_validator = EnumAttributeValidator.new('String', ["VISA", "MASTERCARD", "AMEX", "DISCOVER"])
      return false unless brand_validator.valid?(@brand)
      card_token_source_validator = EnumAttributeValidator.new('String', ["APPLE", "ANDROID", "SAMSUNG"])
      return false unless card_token_source_validator.valid?(@card_token_source)
      return false if !@card_number.nil? && @card_number.to_s.length < 12
      return false if !@cvv.nil? && @cvv.to_s.length > 4
      return false if !@cvv.nil? && @cvv.to_s.length < 3
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] card_type Object to be assigned
    def card_type=(card_type)
      validator = EnumAttributeValidator.new('String', ["DEBIT", "CREDIT"])
      unless validator.valid?(card_type)
        fail ArgumentError, "invalid value for \"card_type\", must be one of #{validator.allowable_values}."
      end
      @card_type = card_type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] brand Object to be assigned
    def brand=(brand)
      validator = EnumAttributeValidator.new('String', ["VISA", "MASTERCARD", "AMEX", "DISCOVER"])
      unless validator.valid?(brand)
        fail ArgumentError, "invalid value for \"brand\", must be one of #{validator.allowable_values}."
      end
      @brand = brand
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] card_token_source Object to be assigned
    def card_token_source=(card_token_source)
      validator = EnumAttributeValidator.new('String', ["APPLE", "ANDROID", "SAMSUNG"])
      unless validator.valid?(card_token_source)
        fail ArgumentError, "invalid value for \"card_token_source\", must be one of #{validator.allowable_values}."
      end
      @card_token_source = card_token_source
    end

    # Custom attribute writer method with validation
    # @param [Object] card_number Value to be assigned
    def card_number=(card_number)
      if !card_number.nil? && card_number.to_s.length < 12
        fail ArgumentError, 'invalid value for "card_number", the character length must be great than or equal to 12.'
      end

      @card_number = card_number
    end

    # Custom attribute writer method with validation
    # @param [Object] cvv Value to be assigned
    def cvv=(cvv)
      if !cvv.nil? && cvv.to_s.length > 4
        fail ArgumentError, 'invalid value for "cvv", the character length must be smaller than or equal to 4.'
      end

      if !cvv.nil? && cvv.to_s.length < 3
        fail ArgumentError, 'invalid value for "cvv", the character length must be great than or equal to 3.'
      end

      @cvv = cvv
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          card_type == o.card_type &&
          brand == o.brand &&
          card_token_source == o.card_token_source &&
          expiration_date == o.expiration_date &&
          billing_address == o.billing_address &&
          card_holder_name == o.card_holder_name &&
          card_token_data == o.card_token_data &&
          card_number == o.card_number &&
          cvv == o.cvv &&
          currency == o.currency
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [card_type, brand, card_token_source, expiration_date, billing_address, card_holder_name, card_token_data, card_number, cvv, currency].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
