=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # The name of the person. It will consist of first, middle, last, additionalLast, honorificPrefix, and honorificSuffix.
  class NameResource
    # The persons title.
    attr_accessor :honorific_prefix

    # The persons first name.
    attr_accessor :first

    # The persons middle name or initial.
    attr_accessor :middle

    # The persons last name.
    attr_accessor :last

    # The 2nd last name of the person.
    attr_accessor :additional_last

    # The persons title.
    attr_accessor :honorific_suffix

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'honorific_prefix' => :'honorificPrefix',
        :'first' => :'first',
        :'middle' => :'middle',
        :'last' => :'last',
        :'additional_last' => :'additionalLast',
        :'honorific_suffix' => :'honorificSuffix'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'honorific_prefix' => :'String',
        :'first' => :'String',
        :'middle' => :'String',
        :'last' => :'String',
        :'additional_last' => :'String',
        :'honorific_suffix' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::NameResource` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::NameResource`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'honorific_prefix')
        self.honorific_prefix = attributes[:'honorific_prefix']
      end

      if attributes.key?(:'first')
        self.first = attributes[:'first']
      end

      if attributes.key?(:'middle')
        self.middle = attributes[:'middle']
      end

      if attributes.key?(:'last')
        self.last = attributes[:'last']
      end

      if attributes.key?(:'additional_last')
        self.additional_last = attributes[:'additional_last']
      end

      if attributes.key?(:'honorific_suffix')
        self.honorific_suffix = attributes[:'honorific_suffix']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @first.nil?
        invalid_properties.push('invalid value for "first", first cannot be nil.')
      end

      if @first.to_s.length > 100
        invalid_properties.push('invalid value for "first", the character length must be smaller than or equal to 100.')
      end

      if @first.to_s.length < 1
        invalid_properties.push('invalid value for "first", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if @first !~ pattern
        invalid_properties.push("invalid value for \"first\", must conform to the pattern #{pattern}.")
      end

      if !@middle.nil? && @middle.to_s.length > 25
        invalid_properties.push('invalid value for "middle", the character length must be smaller than or equal to 25.')
      end

      if !@middle.nil? && @middle.to_s.length < 1
        invalid_properties.push('invalid value for "middle", the character length must be great than or equal to 1.')
      end

      if @last.nil?
        invalid_properties.push('invalid value for "last", last cannot be nil.')
      end

      if @last.to_s.length > 100
        invalid_properties.push('invalid value for "last", the character length must be smaller than or equal to 100.')
      end

      if @last.to_s.length < 1
        invalid_properties.push('invalid value for "last", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if @last !~ pattern
        invalid_properties.push("invalid value for \"last\", must conform to the pattern #{pattern}.")
      end

      if !@additional_last.nil? && @additional_last.to_s.length > 100
        invalid_properties.push('invalid value for "additional_last", the character length must be smaller than or equal to 100.')
      end

      if !@additional_last.nil? && @additional_last.to_s.length < 2
        invalid_properties.push('invalid value for "additional_last", the character length must be great than or equal to 2.')
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !@additional_last.nil? && @additional_last !~ pattern
        invalid_properties.push("invalid value for \"additional_last\", must conform to the pattern #{pattern}.")
      end

      if !@honorific_suffix.nil? && @honorific_suffix.to_s.length > 25
        invalid_properties.push('invalid value for "honorific_suffix", the character length must be smaller than or equal to 25.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      honorific_prefix_validator = EnumAttributeValidator.new('String', ["MR", "MRS", "MS", "MISS", "DR"])
      return false unless honorific_prefix_validator.valid?(@honorific_prefix)
      return false if @first.nil?
      return false if @first.to_s.length > 100
      return false if @first.to_s.length < 1
      return false if @first !~ Regexp.new(/.*[^\s].*/)
      return false if !@middle.nil? && @middle.to_s.length > 25
      return false if !@middle.nil? && @middle.to_s.length < 1
      return false if @last.nil?
      return false if @last.to_s.length > 100
      return false if @last.to_s.length < 1
      return false if @last !~ Regexp.new(/.*[^\s].*/)
      return false if !@additional_last.nil? && @additional_last.to_s.length > 100
      return false if !@additional_last.nil? && @additional_last.to_s.length < 2
      return false if !@additional_last.nil? && @additional_last !~ Regexp.new(/.*[^\s].*/)
      return false if !@honorific_suffix.nil? && @honorific_suffix.to_s.length > 25
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] honorific_prefix Object to be assigned
    def honorific_prefix=(honorific_prefix)
      validator = EnumAttributeValidator.new('String', ["MR", "MRS", "MS", "MISS", "DR"])
      unless validator.valid?(honorific_prefix)
        fail ArgumentError, "invalid value for \"honorific_prefix\", must be one of #{validator.allowable_values}."
      end
      @honorific_prefix = honorific_prefix
    end

    # Custom attribute writer method with validation
    # @param [Object] first Value to be assigned
    def first=(first)
      if first.nil?
        fail ArgumentError, 'first cannot be nil'
      end

      if first.to_s.length > 100
        fail ArgumentError, 'invalid value for "first", the character length must be smaller than or equal to 100.'
      end

      if first.to_s.length < 1
        fail ArgumentError, 'invalid value for "first", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if first !~ pattern
        fail ArgumentError, "invalid value for \"first\", must conform to the pattern #{pattern}."
      end

      @first = first
    end

    # Custom attribute writer method with validation
    # @param [Object] middle Value to be assigned
    def middle=(middle)
      if !middle.nil? && middle.to_s.length > 25
        fail ArgumentError, 'invalid value for "middle", the character length must be smaller than or equal to 25.'
      end

      if !middle.nil? && middle.to_s.length < 1
        fail ArgumentError, 'invalid value for "middle", the character length must be great than or equal to 1.'
      end

      @middle = middle
    end

    # Custom attribute writer method with validation
    # @param [Object] last Value to be assigned
    def last=(last)
      if last.nil?
        fail ArgumentError, 'last cannot be nil'
      end

      if last.to_s.length > 100
        fail ArgumentError, 'invalid value for "last", the character length must be smaller than or equal to 100.'
      end

      if last.to_s.length < 1
        fail ArgumentError, 'invalid value for "last", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if last !~ pattern
        fail ArgumentError, "invalid value for \"last\", must conform to the pattern #{pattern}."
      end

      @last = last
    end

    # Custom attribute writer method with validation
    # @param [Object] additional_last Value to be assigned
    def additional_last=(additional_last)
      if !additional_last.nil? && additional_last.to_s.length > 100
        fail ArgumentError, 'invalid value for "additional_last", the character length must be smaller than or equal to 100.'
      end

      if !additional_last.nil? && additional_last.to_s.length < 2
        fail ArgumentError, 'invalid value for "additional_last", the character length must be great than or equal to 2.'
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !additional_last.nil? && additional_last !~ pattern
        fail ArgumentError, "invalid value for \"additional_last\", must conform to the pattern #{pattern}."
      end

      @additional_last = additional_last
    end

    # Custom attribute writer method with validation
    # @param [Object] honorific_suffix Value to be assigned
    def honorific_suffix=(honorific_suffix)
      if !honorific_suffix.nil? && honorific_suffix.to_s.length > 25
        fail ArgumentError, 'invalid value for "honorific_suffix", the character length must be smaller than or equal to 25.'
      end

      @honorific_suffix = honorific_suffix
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          honorific_prefix == o.honorific_prefix &&
          first == o.first &&
          middle == o.middle &&
          last == o.last &&
          additional_last == o.additional_last &&
          honorific_suffix == o.honorific_suffix
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [honorific_prefix, first, middle, last, additional_last, honorific_suffix].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
