=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # The owner of the asset
  class OwnerResource
    # id of the applicant
    attr_accessor :id

    # The persons first name.
    attr_accessor :first

    # The persons last name.
    attr_accessor :last

    attr_accessor :address

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'first' => :'first',
        :'last' => :'last',
        :'address' => :'address'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'id' => :'String',
        :'first' => :'String',
        :'last' => :'String',
        :'address' => :'AddressResource'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::OwnerResource` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::OwnerResource`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.key?(:'first')
        self.first = attributes[:'first']
      end

      if attributes.key?(:'last')
        self.last = attributes[:'last']
      end

      if attributes.key?(:'address')
        self.address = attributes[:'address']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @first.nil?
        invalid_properties.push('invalid value for "first", first cannot be nil.')
      end

      if @first.to_s.length > 100
        invalid_properties.push('invalid value for "first", the character length must be smaller than or equal to 100.')
      end

      if @first.to_s.length < 1
        invalid_properties.push('invalid value for "first", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if @first !~ pattern
        invalid_properties.push("invalid value for \"first\", must conform to the pattern #{pattern}.")
      end

      if @last.nil?
        invalid_properties.push('invalid value for "last", last cannot be nil.')
      end

      if @last.to_s.length > 100
        invalid_properties.push('invalid value for "last", the character length must be smaller than or equal to 100.')
      end

      if @last.to_s.length < 1
        invalid_properties.push('invalid value for "last", the character length must be great than or equal to 1.')
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if @last !~ pattern
        invalid_properties.push("invalid value for \"last\", must conform to the pattern #{pattern}.")
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @first.nil?
      return false if @first.to_s.length > 100
      return false if @first.to_s.length < 1
      return false if @first !~ Regexp.new(/.*[^\s].*/)
      return false if @last.nil?
      return false if @last.to_s.length > 100
      return false if @last.to_s.length < 1
      return false if @last !~ Regexp.new(/.*[^\s].*/)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] first Value to be assigned
    def first=(first)
      if first.nil?
        fail ArgumentError, 'first cannot be nil'
      end

      if first.to_s.length > 100
        fail ArgumentError, 'invalid value for "first", the character length must be smaller than or equal to 100.'
      end

      if first.to_s.length < 1
        fail ArgumentError, 'invalid value for "first", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if first !~ pattern
        fail ArgumentError, "invalid value for \"first\", must conform to the pattern #{pattern}."
      end

      @first = first
    end

    # Custom attribute writer method with validation
    # @param [Object] last Value to be assigned
    def last=(last)
      if last.nil?
        fail ArgumentError, 'last cannot be nil'
      end

      if last.to_s.length > 100
        fail ArgumentError, 'invalid value for "last", the character length must be smaller than or equal to 100.'
      end

      if last.to_s.length < 1
        fail ArgumentError, 'invalid value for "last", the character length must be great than or equal to 1.'
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if last !~ pattern
        fail ArgumentError, "invalid value for \"last\", must conform to the pattern #{pattern}."
      end

      @last = last
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          first == o.first &&
          last == o.last &&
          address == o.address
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [id, first, last, address].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
