=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # Information about the properties price settings including min/max rate, and different fees.
  class PriceSettingResource
    attr_accessor :min_rate

    attr_accessor :max_rate

    attr_accessor :cleaning_fee

    # Is there a same day charge for the property.
    attr_accessor :same_day_charge_allowed

    # Is auto pricing setup for the property.
    attr_accessor :auto_pricing

    # The renting frequencey for the property.
    attr_accessor :renting_frequency

    # The terms of payment for the property for a traveler [single, multiple].
    attr_accessor :payment_terms

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'min_rate' => :'minRate',
        :'max_rate' => :'maxRate',
        :'cleaning_fee' => :'cleaningFee',
        :'same_day_charge_allowed' => :'sameDayChargeAllowed',
        :'auto_pricing' => :'autoPricing',
        :'renting_frequency' => :'rentingFrequency',
        :'payment_terms' => :'paymentTerms'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'min_rate' => :'MoneyResource',
        :'max_rate' => :'MoneyResource',
        :'cleaning_fee' => :'MoneyResource',
        :'same_day_charge_allowed' => :'Boolean',
        :'auto_pricing' => :'Boolean',
        :'renting_frequency' => :'String',
        :'payment_terms' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::PriceSettingResource` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::PriceSettingResource`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'min_rate')
        self.min_rate = attributes[:'min_rate']
      end

      if attributes.key?(:'max_rate')
        self.max_rate = attributes[:'max_rate']
      end

      if attributes.key?(:'cleaning_fee')
        self.cleaning_fee = attributes[:'cleaning_fee']
      end

      if attributes.key?(:'same_day_charge_allowed')
        self.same_day_charge_allowed = attributes[:'same_day_charge_allowed']
      end

      if attributes.key?(:'auto_pricing')
        self.auto_pricing = attributes[:'auto_pricing']
      end

      if attributes.key?(:'renting_frequency')
        self.renting_frequency = attributes[:'renting_frequency']
      end

      if attributes.key?(:'payment_terms')
        self.payment_terms = attributes[:'payment_terms']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      renting_frequency_validator = EnumAttributeValidator.new('String', ["LESS_THAN_ONE_MONTH", "ONE_TO_THREE_MONTHS", "THREE_TO_SIX_MONTHS", "SIX_OR_MORE_MONTHS"])
      return false unless renting_frequency_validator.valid?(@renting_frequency)
      payment_terms_validator = EnumAttributeValidator.new('String', ["SINGLE_CHARGE", "MULTIPLE_CHARGES"])
      return false unless payment_terms_validator.valid?(@payment_terms)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] renting_frequency Object to be assigned
    def renting_frequency=(renting_frequency)
      validator = EnumAttributeValidator.new('String', ["LESS_THAN_ONE_MONTH", "ONE_TO_THREE_MONTHS", "THREE_TO_SIX_MONTHS", "SIX_OR_MORE_MONTHS"])
      unless validator.valid?(renting_frequency)
        fail ArgumentError, "invalid value for \"renting_frequency\", must be one of #{validator.allowable_values}."
      end
      @renting_frequency = renting_frequency
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] payment_terms Object to be assigned
    def payment_terms=(payment_terms)
      validator = EnumAttributeValidator.new('String', ["SINGLE_CHARGE", "MULTIPLE_CHARGES"])
      unless validator.valid?(payment_terms)
        fail ArgumentError, "invalid value for \"payment_terms\", must be one of #{validator.allowable_values}."
      end
      @payment_terms = payment_terms
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          min_rate == o.min_rate &&
          max_rate == o.max_rate &&
          cleaning_fee == o.cleaning_fee &&
          same_day_charge_allowed == o.same_day_charge_allowed &&
          auto_pricing == o.auto_pricing &&
          renting_frequency == o.renting_frequency &&
          payment_terms == o.payment_terms
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [min_rate, max_rate, cleaning_fee, same_day_charge_allowed, auto_pricing, renting_frequency, payment_terms].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
