=begin
#Yapstone Staged On-Boarding Services

#Set of API's that allow clients to onboard with Yapstone.

The version of the OpenAPI document: 2.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # User profile information. Contains data about the person such as name, address, phone, email, etc.
  class ProfileResource
    attr_accessor :name

    attr_accessor :address

    attr_accessor :phone

    # The email address.
    attr_accessor :email

    attr_accessor :gov_identification

    attr_accessor :gender

    # The date of birth for the person.
    attr_accessor :date_of_birth

    # The country of birth for the person.
    attr_accessor :country_of_birth

    # The nationality of the person.
    attr_accessor :nationality

    # The website hostname.
    attr_accessor :website_url

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'name' => :'name',
        :'address' => :'address',
        :'phone' => :'phone',
        :'email' => :'email',
        :'gov_identification' => :'govIdentification',
        :'gender' => :'gender',
        :'date_of_birth' => :'dateOfBirth',
        :'country_of_birth' => :'countryOfBirth',
        :'nationality' => :'nationality',
        :'website_url' => :'websiteURL'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'name' => :'NameResource',
        :'address' => :'AddressResource',
        :'phone' => :'PhoneResource',
        :'email' => :'String',
        :'gov_identification' => :'GovIdentificationResource',
        :'gender' => :'Gender',
        :'date_of_birth' => :'Date',
        :'country_of_birth' => :'String',
        :'nationality' => :'String',
        :'website_url' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::ProfileResource` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::ProfileResource`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'address')
        self.address = attributes[:'address']
      end

      if attributes.key?(:'phone')
        self.phone = attributes[:'phone']
      end

      if attributes.key?(:'email')
        self.email = attributes[:'email']
      end

      if attributes.key?(:'gov_identification')
        self.gov_identification = attributes[:'gov_identification']
      end

      if attributes.key?(:'gender')
        self.gender = attributes[:'gender']
      end

      if attributes.key?(:'date_of_birth')
        self.date_of_birth = attributes[:'date_of_birth']
      end

      if attributes.key?(:'country_of_birth')
        self.country_of_birth = attributes[:'country_of_birth']
      end

      if attributes.key?(:'nationality')
        self.nationality = attributes[:'nationality']
      end

      if attributes.key?(:'website_url')
        self.website_url = attributes[:'website_url']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @address.nil?
        invalid_properties.push('invalid value for "address", address cannot be nil.')
      end

      if !@email.nil? && @email.to_s.length > 512
        invalid_properties.push('invalid value for "email", the character length must be smaller than or equal to 512.')
      end

      if !@email.nil? && @email.to_s.length < 1
        invalid_properties.push('invalid value for "email", the character length must be great than or equal to 1.')
      end

      if !@country_of_birth.nil? && @country_of_birth.to_s.length > 3
        invalid_properties.push('invalid value for "country_of_birth", the character length must be smaller than or equal to 3.')
      end

      if !@country_of_birth.nil? && @country_of_birth.to_s.length < 3
        invalid_properties.push('invalid value for "country_of_birth", the character length must be great than or equal to 3.')
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !@country_of_birth.nil? && @country_of_birth !~ pattern
        invalid_properties.push("invalid value for \"country_of_birth\", must conform to the pattern #{pattern}.")
      end

      if !@nationality.nil? && @nationality.to_s.length > 3
        invalid_properties.push('invalid value for "nationality", the character length must be smaller than or equal to 3.')
      end

      if !@nationality.nil? && @nationality.to_s.length < 3
        invalid_properties.push('invalid value for "nationality", the character length must be great than or equal to 3.')
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !@nationality.nil? && @nationality !~ pattern
        invalid_properties.push("invalid value for \"nationality\", must conform to the pattern #{pattern}.")
      end

      if !@website_url.nil? && @website_url.to_s.length > 24
        invalid_properties.push('invalid value for "website_url", the character length must be smaller than or equal to 24.')
      end

      if !@website_url.nil? && @website_url.to_s.length < 4
        invalid_properties.push('invalid value for "website_url", the character length must be great than or equal to 4.')
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !@website_url.nil? && @website_url !~ pattern
        invalid_properties.push("invalid value for \"website_url\", must conform to the pattern #{pattern}.")
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @name.nil?
      return false if @address.nil?
      return false if !@email.nil? && @email.to_s.length > 512
      return false if !@email.nil? && @email.to_s.length < 1
      return false if !@country_of_birth.nil? && @country_of_birth.to_s.length > 3
      return false if !@country_of_birth.nil? && @country_of_birth.to_s.length < 3
      return false if !@country_of_birth.nil? && @country_of_birth !~ Regexp.new(/.*[^\s].*/)
      return false if !@nationality.nil? && @nationality.to_s.length > 3
      return false if !@nationality.nil? && @nationality.to_s.length < 3
      return false if !@nationality.nil? && @nationality !~ Regexp.new(/.*[^\s].*/)
      return false if !@website_url.nil? && @website_url.to_s.length > 24
      return false if !@website_url.nil? && @website_url.to_s.length < 4
      return false if !@website_url.nil? && @website_url !~ Regexp.new(/.*[^\s].*/)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] email Value to be assigned
    def email=(email)
      if !email.nil? && email.to_s.length > 512
        fail ArgumentError, 'invalid value for "email", the character length must be smaller than or equal to 512.'
      end

      if !email.nil? && email.to_s.length < 1
        fail ArgumentError, 'invalid value for "email", the character length must be great than or equal to 1.'
      end

      @email = email
    end

    # Custom attribute writer method with validation
    # @param [Object] country_of_birth Value to be assigned
    def country_of_birth=(country_of_birth)
      if !country_of_birth.nil? && country_of_birth.to_s.length > 3
        fail ArgumentError, 'invalid value for "country_of_birth", the character length must be smaller than or equal to 3.'
      end

      if !country_of_birth.nil? && country_of_birth.to_s.length < 3
        fail ArgumentError, 'invalid value for "country_of_birth", the character length must be great than or equal to 3.'
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !country_of_birth.nil? && country_of_birth !~ pattern
        fail ArgumentError, "invalid value for \"country_of_birth\", must conform to the pattern #{pattern}."
      end

      @country_of_birth = country_of_birth
    end

    # Custom attribute writer method with validation
    # @param [Object] nationality Value to be assigned
    def nationality=(nationality)
      if !nationality.nil? && nationality.to_s.length > 3
        fail ArgumentError, 'invalid value for "nationality", the character length must be smaller than or equal to 3.'
      end

      if !nationality.nil? && nationality.to_s.length < 3
        fail ArgumentError, 'invalid value for "nationality", the character length must be great than or equal to 3.'
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !nationality.nil? && nationality !~ pattern
        fail ArgumentError, "invalid value for \"nationality\", must conform to the pattern #{pattern}."
      end

      @nationality = nationality
    end

    # Custom attribute writer method with validation
    # @param [Object] website_url Value to be assigned
    def website_url=(website_url)
      if !website_url.nil? && website_url.to_s.length > 24
        fail ArgumentError, 'invalid value for "website_url", the character length must be smaller than or equal to 24.'
      end

      if !website_url.nil? && website_url.to_s.length < 4
        fail ArgumentError, 'invalid value for "website_url", the character length must be great than or equal to 4.'
      end

      pattern = Regexp.new(/.*[^\s].*/)
      if !website_url.nil? && website_url !~ pattern
        fail ArgumentError, "invalid value for \"website_url\", must conform to the pattern #{pattern}."
      end

      @website_url = website_url
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          name == o.name &&
          address == o.address &&
          phone == o.phone &&
          email == o.email &&
          gov_identification == o.gov_identification &&
          gender == o.gender &&
          date_of_birth == o.date_of_birth &&
          country_of_birth == o.country_of_birth &&
          nationality == o.nationality &&
          website_url == o.website_url
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [name, address, phone, email, gov_identification, gender, date_of_birth, country_of_birth, nationality, website_url].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
